﻿using Microsoft.AspNetCore.Builder;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1.DI;

interface IClassA { }
interface IClassB { }

class ClassA : IClassA
{
    public ClassA(IClassB classB) { }
}
class ClassB : IClassB
{
    public ClassB(IClassA classB) { }
}

internal class CricularDependency
{
    public static void Test()
    {
        var builder = WebApplication.CreateBuilder();

        builder.Services.AddSingleton<IClassA, ClassA>();
        builder.Services.AddSingleton<IClassB, ClassB>();

        var app = builder.Build();

        app.MapGet("/", (IClassA classA) => "test");

        app.Run();
    }
}
