﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace AwInitilizer.Assist
{
    public class EvHttpClientResult
    {
        public bool IsSuccess { get; set; }
        public string Msg { get; set; }
    }

    public class EvAuthMsg
    {
        public string result { get; set; }
        public object message { get; set; }
    }

    public static class EvHttpClient
    {
        private static string account = "adminf";
        private static string pass = "1231231238";
        //internal static string ServerIpAddress = "192.168.1.10";
        //internal static string ServerUrl = "https://192.168.1.10";
        //updated EV
        internal static string ServerIpAddress = "192.168.80.179";
        internal static string ServerUrl = "https://192.168.80.179";
        //original EV
        //internal static string ServerIpAddress = "192.168.80.199";
        //internal static string ServerUrl = "https://192.168.80.199";

        internal static Task<EvHttpClientResult> GetQueryActionOpt1String()
        {
            string api = "get_query_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>() {
                {"opt","1"}
            };
            return CallBase(api, param);
        }

        internal static Task<EvHttpClientResult> GetQueryActionOpt2String()
        {
            string api = "get_query_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>() {
                {"opt","2"}
            };
            return CallBase(api, param);
        }

        internal static Task<EvHttpClientResult> GetQueryActionOpt3String()
        {
            string api = "get_query_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>() {
                {"opt","3"}
            };
            return CallBase(api, param);
        }

        internal static Task<EvHttpClientResult> GetButtonStatusString()
        {
            string api = "get_button_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>()
            {
            };
            return CallBase(api, param);
        }

        internal static Task<EvHttpClientResult> GetFactorySetResultString()
        {
            string api = "set_system_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>();
            param.Add("SystemId", "");
            param.Add("SystemDateTime", "");
            param.Add("PhaseLossPolicy", "");
            param.Add("FactoryConfiguration", "1");
            param.Add("AuthorisationMode", "");
            param.Add("isAPP", "");
            param.Add("isQRCode", "");
            param.Add("isRFID", "");
            param.Add("QRCodeMadeMode", "");
            param.Add("QRCodeContent", "");
            param.Add("Intensity", "");
            param.Add("RfidCardNumEndian", "");
            param.Add("PsuAcInputType", "");
            return CallBase(api, param);
        }

        internal static Task<EvHttpClientResult> GetUploadfirmwareResultString(List<string> fileNames)
        {
            string api = "upgrade_iso_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>(){
                {"fw_tag","iso"}
            };
            return CallBase(api, param, firmwareNames: fileNames);
        }

        internal static Task<EvHttpClientResult> GetSignalUpdateFirmwareResultString()
        {
            string api = "upgrade_iso_action.php";
            Dictionary<string, string> param = new Dictionary<string, string>(){
                {"fw_tag","iso"},
            };
            var dummyFileCotent = new ByteArrayContent(new byte[0]);
            dummyFileCotent.Headers.ContentDisposition
              = new ContentDispositionHeaderValue("attachment")
              {
                  FileName = "temp.txt",
                  Size = 0,
                  CreationDate = DateTime.Now,
                  ModificationDate = DateTime.Now,
                  ReadDate = DateTime.Now,
                  Name = "files[]"
              };

            return CallBase(api, param, customContents: new List<HttpContent>() { dummyFileCotent });
        }

        private static async Task<EvHttpClientResult> CallBase(
            string api,
            Dictionary<string, string> param,
            List<string> firmwareNames = null,
            List<HttpContent> customContents = null)
        {
            try
            {
                var url = string.Format("{0}/{1}", ServerUrl, api);
                Dictionary<string, string> pams = new Dictionary<string, string>
                {
                    { "account", account },
                    { "password", pass }
                };
                foreach (var pam in param)
                {
                    pams.Add(pam.Key, pam.Value);
                }


                var formContent = new MultipartFormDataContent();
                foreach (var pam in pams)
                {
                    formContent.Add(new StringContent(pam.Value), pam.Key);
                }

                if (firmwareNames != null)
                {
                    if (firmwareNames.Count == 1)
                    {
                        var fileName = firmwareNames[0];
                        formContent.Add(new ByteArrayContent(System.IO.File.ReadAllBytes(fileName)), "file");
                    }
                    else
                    {
                        foreach (var fileName in firmwareNames)
                        {
                            formContent.Add(new ByteArrayContent(System.IO.File.ReadAllBytes(fileName)), "file[]");
                        }
                    }
                }

                if (customContents != null)
                {
                    foreach (var content in customContents)
                    {
                        formContent.Add(content);
                    }
                }

                HttpResponseMessage postResult;
                string result = null;


                var handler = new HttpClientHandler();
                handler.ClientCertificateOptions = ClientCertificateOption.Manual;
                handler.ServerCertificateCustomValidationCallback =
                    (httpRequestMessage, cert, cetChain, policyErrors) =>
                    {
                        return true;
                    };

                using (HttpClient evClient = new HttpClient(handler))
                {
                    evClient.Timeout = TimeSpan.FromSeconds(5);

                    try
                    {
                        postResult = await evClient.PostAsync(url, formContent);
                        if (postResult == null || !postResult.IsSuccessStatusCode)
                        {
                            throw new Exception("Post fail");
                        }
                        result = await postResult.Content.ReadAsStringAsync();

                        if (result.Contains("File is uploaded, please wait a moment to upgrade"))
                        {
                            return new EvHttpClientResult()
                            {
                                IsSuccess = true,
                                Msg = result,
                            };
                        }

                        var check = JsonConvert.DeserializeObject<EvAuthMsg>(result);
                        if (check != null &&
                            check.result != null &&
                            check.result.ToLower() == "fail")
                        {
                            return new EvHttpClientResult() { 
                                IsSuccess = false,
                                Msg = result,
                            };
                        }

                        return new EvHttpClientResult()
                        {
                            IsSuccess = true,
                            Msg = result,
                        };
                    }
                    catch
                    {
                        //post fail
                    }
                }

                using (WebClientTimeout webClient = new WebClientTimeout())
                {
                    NameValueCollection parameters = new NameValueCollection();
                    foreach (var inpam in param)
                    {
                        parameters.Add(inpam.Key, inpam.Value);
                    }
                    webClient.QueryString = parameters;

                    using (Stream stream = webClient.OpenRead(url))
                    // 使用 StreamReader 讀取 stream 內的字元
                    using (StreamReader reader = new StreamReader(stream))
                    {
                        // 將 StreamReader 所讀到的字元轉為 string
                        result = await reader.ReadToEndAsync();
                    }

                    var check = JsonConvert.DeserializeObject<EvAuthMsg>(result);
                    if (check != null &&
                        check.result != null &&
                        check.result.ToLower() == "fail")
                    {
                        return new EvHttpClientResult()
                        {
                            IsSuccess = false,
                            Msg = result,
                        };
                    }
                }
                return new EvHttpClientResult() { IsSuccess = true, Msg = result };

            }
            catch (Exception e)
            {
                return new EvHttpClientResult() { IsSuccess = false, Msg = e.Message }; ;
            }
        }
    }
}
